package com.tjise.asked;

import android.app.AlertDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.google.common.hash.Hashing;
import com.google.gson.Gson;
import com.tjise.asked.adapter.MultipleSelectAdapter;
import com.tjise.asked.adapter.MultipleFillInTheBlanksListAdapter;
import com.tjise.asked.adapter.MultipleOptionWitTipAdapter;
import com.tjise.asked.adapter.MultipleSelectWithTipAdapter;
import com.tjise.asked.adapter.QuestionAdapter;
import com.tjise.asked.adapter.SelectAdapter;
import com.tjise.asked.dto.FillInTheBlankDTO;
import com.tjise.asked.http.BaseBean;
import com.tjise.asked.http.RetrofitClient;
import com.tjise.asked.http.response.QuestionResponse;
import com.tjise.asked.http.response.GetAllQueByPaperIdResponse;
import com.tjise.asked.http.request.SavePaperResultRequest;
import com.tjise.asked.http.response.SavePaperResultResponse;
import com.tjise.asked.util.SpUtils;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import io.reactivex.rxjava3.android.schedulers.AndroidSchedulers;
import io.reactivex.rxjava3.core.Observer;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.schedulers.Schedulers;
import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.Headers;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class MainActivity extends AppCompatActivity {

    private static final String TAG = "MainActivity";

    MediaType JSON = MediaType.parse("application/json;charset=utf-8");

    private String appKey = "258e55090c6e47d7a6dd985ef292c2c5";

    private String appToken = "19KtpFuXYc363qnS";

    private Integer baseId;

    private Button btnNext;

    private Button btnPrevious;

    private Integer displaySeq;

    int[] displaySeqMipmapArr = new int[] { R.mipmap.display_seq_1, R.mipmap.display_seq_2, R.mipmap.display_seq_3, R.mipmap.display_seq_4, R.mipmap.display_seq_5, R.mipmap.display_seq_6, R.mipmap.display_seq_7, R.mipmap.display_seq_8, R.mipmap.display_seq_9, R.mipmap.display_seq_10 };

    private EditText etBlank;

    List<FillInTheBlankDTO> fillInTheBlankList;

    List<Integer> finishQueIdList = new ArrayList<>();

    List<GetAllQueByPaperIdResponse> getAllQueByPaperIdResponseList;

    private ImageView ivAll;

    ImageView ivSeq;

    private Integer jumpQueId;

    List<List<QuestionResponse.NextQueVODTO.OptionListDTO>> optionList;

    private Integer paperId;

    private Integer queId;

    private String queType;

    QuestionAdapter questionAdapter;

    private RecyclerView rvOption;

    private String serialNumber = "PX4675";

    private Integer stepId;

    private String stepName;

    private TextView tvDesc;

    private TextView tvStem;

    private TextView tvTitle;
    SpUtils spUtils;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // 获取当前Activity的SupportActionBar
        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            // 如果ActionBar不为空，则隐藏它
            actionBar.hide();
        }

        setContentView(R.layout.activity_main);
        spUtils = new SpUtils(this);

        this.baseId = spUtils.getInt("baseId", 0);
        this.tvStem = findViewById(R.id.tv_stem);
        this.tvDesc = findViewById(R.id.tv_desc);
        this.rvOption = findViewById(R.id.rv_option);
        this.btnNext = findViewById(R.id.btn_next);
        this.btnPrevious = findViewById(R.id.btn_previous);
        this.etBlank =  findViewById(R.id.et_blank);
        this.tvTitle =  findViewById(R.id.tv_title);
        this.ivSeq =  findViewById(R.id.iv_seq);
        this.ivAll =  findViewById(R.id.iv_all);
        findViewById(R.id.view_back_home).setOnClickListener(v -> {

        });
        this.btnNext.setOnClickListener(v -> {
            savePaperResult(1);
//            queryNextQuestion();
        });
        this.btnPrevious.setOnClickListener(v -> {
            savePaperResult(2);
//            getBeforePaperQueInfo();
        });
        this.ivAll.setOnClickListener(v -> showQuestionList());
        queryNextQuestion();
        queryAllQuestion();
    }

    private void getBeforePaperQueInfo() {
        RetrofitClient.getInstance().getApiService().getBeforePaperQueInfo(1, this.stepId, this.baseId, this.queId).subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<BaseBean<QuestionResponse>>() {

            public void onComplete() {}

            public void onError(Throwable param1Throwable) {}

            public void onNext(BaseBean<QuestionResponse> param1BaseBean) {
                if (param1BaseBean.getData() == null) {
                    Toast.makeText(MainActivity.this, "本题已经是第一题了，请点击下一题", Toast.LENGTH_SHORT).show();
                    return;
                }
                setData(param1BaseBean);
            }

            public void onSubscribe(Disposable param1Disposable) {}
        });
    }

    private void getPaperQueInfoById() {
        RetrofitClient.getInstance().getApiService().getPaperQueInfoById(this.baseId, this.jumpQueId).subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<BaseBean<QuestionResponse>>() {

            public void onComplete() {}

            public void onError(Throwable param1Throwable) {}

            public void onNext(BaseBean<QuestionResponse> param1BaseBean) {
                if (param1BaseBean.getData() == null) {
                    Toast.makeText(MainActivity.this, "本题已经是第一题了，请点击下一题", Toast.LENGTH_SHORT).show();
                    return;
                }
                setData(param1BaseBean);
            }

            public void onSubscribe(Disposable param1Disposable) {}
        });
    }

    private String getSign(TreeMap<String, Object> paramTreeMap) {
        String str2 = "";
        for (Map.Entry<String, Object> entry : paramTreeMap.entrySet())
            str2 = str2 + (String)entry.getKey() + ":" + entry.getValue().toString() + ",";
        long l = System.currentTimeMillis() / 1000L;
        paramTreeMap.put("time", String.valueOf(l));
        String str1 = str2 + "time:" + l + ",";
        str1 = str1 + "appkey:" + this.appKey + ",";
        str1 = str1 + "apptoken:" + this.appToken;
        Log.i("MainActivity", "playVoice getSign: toSignStr = " + str1);
        return Hashing.md5().hashBytes(str1.getBytes()).toString().toLowerCase();
    }

    private void playVoice(BaseBean<QuestionResponse> paramBaseBean) {
        String str = paramBaseBean.getData().getNextQueVO().getQueTitle();
        final OkHttpClient okHttpClient = RetrofitClient.getInstance().getOkHttpClient();
        TreeMap<Object, Object> treeMap = new TreeMap<>();
        treeMap.put("serialNumber", this.serialNumber);
        treeMap.put("synthesisContent", str);
        str = getSign((TreeMap)treeMap);
        HashMap<Object, Object> hashMap = new HashMap<>();
        hashMap.put("time", Long.valueOf(Long.parseLong(treeMap.get("time").toString())));
        treeMap.remove("time");
        hashMap.put("appkey", this.appKey);
        hashMap.put("language", "zh-CN");
        hashMap.put("sign", str);
        treeMap.put("system", hashMap);
        Gson gson = new Gson();
        Log.i("MainActivity", "playVoice: json = " + gson.toJson(treeMap));
        RequestBody requestBody = RequestBody.create(this.JSON, gson.toJson(treeMap));
        (new Thread(new Runnable() {
            Request request = new Request.Builder()
                    .url("http://example.com")
                    .post(requestBody)
                    .build();
            public void run() {
                okHttpClient.newCall(request).enqueue(new Callback() {

                    public void onFailure(Call param2Call, IOException param2IOException) {
                        Log.d("MainActivity", "onFailure: " + param2IOException.getMessage());
                    }

                    public void onResponse(Call param2Call, Response param2Response) throws IOException {
                        Log.d("MainActivity", param2Response.protocol() + " " + param2Response.code() + " " + param2Response.message());
                        Headers headers = param2Response.headers();
                        for (byte b = 0; b < headers.size(); b++)
                            Log.d("MainActivity", headers.name(b) + ":" + headers.value(b));
                        Log.d("MainActivity", "playVoice onResponse: " + param2Response.body().string());
                    }
                });
            }
        })).start();
    }

    private void queryAllQuestion() {
        RetrofitClient.getInstance().getApiService().getAllQueByPaperId(Integer.valueOf(1)).subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<BaseBean<List<GetAllQueByPaperIdResponse>>>() {

            public void onComplete() {}

            public void onError(Throwable param1Throwable) {}

            public void onNext(BaseBean<List<GetAllQueByPaperIdResponse>> param1BaseBean) {
                getAllQueByPaperIdResponseList = param1BaseBean.getData();
                for (GetAllQueByPaperIdResponse response : getAllQueByPaperIdResponseList) {
                    response.setFinished(false);
                }
            }

            public void onSubscribe(Disposable param1Disposable) {}
        });
    }

    private void queryNextQuestion() {
        RetrofitClient.getInstance().getApiService().getNextPaperQueInfo(Integer.valueOf(1), this.stepId, this.baseId, this.queId).subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<BaseBean<QuestionResponse>>() {

            public void onComplete() {}

            public void onError(Throwable param1Throwable) {}

            public void onNext(BaseBean<QuestionResponse> param1BaseBean) {
                Intent intent;
                if (param1BaseBean.getData() == null) {
                    intent = new Intent(MainActivity.this, ResultActivity.class);
                    startActivity(intent);
                    finish();
                    return;
                }
                setData(param1BaseBean);
            }

            public void onSubscribe(Disposable param1Disposable) {}
        });
    }

    private void savePaperResult(final Integer type) {
        Gson gson = new Gson();
        SavePaperResultRequest savePaperResultRequest = new SavePaperResultRequest();
        savePaperResultRequest.setQueId(this.queId);
        savePaperResultRequest.setPaperId(this.paperId);
        savePaperResultRequest.setBaseId(this.baseId);
        savePaperResultRequest.setStepId(this.stepId);
        String str = "";
        if (this.queType.equals("ANSWER")) {
            str = this.etBlank.getText().toString();
            if ("".equals(str)) {
                Toast.makeText(this, "请填写答案", Toast.LENGTH_SHORT).show();
                return;
            }
            this.etBlank.setText("");
        } else if (this.queType.equals("FILL")) {
            for (FillInTheBlankDTO fillInTheBlankDTO : this.fillInTheBlankList) {
                if (fillInTheBlankDTO.getContent() == null || "".equals(fillInTheBlankDTO.getContent()) || "null".equals(fillInTheBlankDTO.getContent())) {
                    Toast.makeText((Context)this, "请填写答案", Toast.LENGTH_SHORT).show();
                    return;
                }
                str = str + fillInTheBlankDTO.getContent() + "#@#";
            }
        } else {
            Iterator<List<QuestionResponse.NextQueVODTO.OptionListDTO>> iterator = this.optionList.iterator();
            String str1 = str;
            while (iterator.hasNext()) {
                for (QuestionResponse.NextQueVODTO.OptionListDTO optionListDTO : iterator.next()) {
                    str = str1;
                    if (optionListDTO.getChecked().booleanValue())
                        str = str1 + optionListDTO.getId() + "#@#";
                    str1 = str;
                }
            }
            str = str1;
            if (str1.endsWith("#@#"))
                str = str1.substring(0, str1.length() - 3);
        }
        savePaperResultRequest.setAnswerResult(str);
        for (GetAllQueByPaperIdResponse getAllQueByPaperIdResponse : this.getAllQueByPaperIdResponseList) {
            if (getAllQueByPaperIdResponse.getId() == this.queId)
                getAllQueByPaperIdResponse.setFinished(Boolean.valueOf(true));
        }
        QuestionAdapter questionAdapter = this.questionAdapter;
        if (questionAdapter != null)
            questionAdapter.notifyDataSetChanged();
        stopPlayVoice();
        RequestBody requestBody = RequestBody.create(MediaType.parse("application/json"), gson.toJson(savePaperResultRequest));
        RetrofitClient.getInstance().getApiService().savePaperResult(requestBody).subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<BaseBean<SavePaperResultResponse>>() {


            public void onComplete() {}

            public void onError(Throwable param1Throwable) {}

            public void onNext(BaseBean<SavePaperResultResponse> param1BaseBean) {
                if (type.intValue() == 1) {
                    queryNextQuestion();
                } else if (type.intValue() == 2) {
                    getBeforePaperQueInfo();
                } else {
                    getPaperQueInfoById();
                }
            }

            public void onSubscribe(Disposable param1Disposable) {}
        });
    }

    private void setData(BaseBean<QuestionResponse> paramBaseBean) {
        LinearLayoutManager linearLayoutManager;
        playVoice(paramBaseBean);
        String str = paramBaseBean.getData().getNextQueVO().getRemark();
        boolean bool = "first".equals(str);
        byte b = 0;
        if (bool) {
            this.btnPrevious.setVisibility(View.GONE);
            this.btnNext.setVisibility(View.VISIBLE);
        } else if ("end".equals(str)) {
            this.btnPrevious.setVisibility(View.VISIBLE);
            this.btnNext.setVisibility(View.GONE);
        } else {
            this.btnPrevious.setVisibility(View.VISIBLE);
            this.btnNext.setVisibility(View.VISIBLE);
        }
        this.queId = paramBaseBean.getData().getNextQueVO().getId();
        this.paperId = paramBaseBean.getData().getNextQueVO().getPaperId();
        this.stepId = paramBaseBean.getData().getNextQueVO().getStepId();
        this.queType = paramBaseBean.getData().getNextQueVO().getQueType();
        this.stepName = paramBaseBean.getData().getStepName();
        Integer integer = paramBaseBean.getData().getDisplaySeq();
        this.displaySeq = integer;
        this.ivSeq.setImageResource(this.displaySeqMipmapArr[integer.intValue() - 1]);
        this.tvTitle.setText(this.stepName);
        this.tvStem.setText(paramBaseBean.getData().getNextQueVO().getQueSeq() + "  " + paramBaseBean.getData().getNextQueVO().getQueTitle());
        this.tvDesc.setText(paramBaseBean.getData().getNextQueVO().getQueDesc());
        this.optionList = paramBaseBean.getData().getNextQueVO().getOptionList();
        if (paramBaseBean.getData().getNextQueVO().getQueType().equals("MUTSELECTD")) {
            this.rvOption.setVisibility(View.VISIBLE);
            this.etBlank.setVisibility(View.GONE);
            if (paramBaseBean.getData().getNextQueVO().getExistDesc().booleanValue()) {
                MultipleSelectWithTipAdapter multipleSelectWithTipAdapter = new MultipleSelectWithTipAdapter(this, this.optionList);
                this.rvOption.setAdapter(multipleSelectWithTipAdapter);
            } else {
                MultipleSelectAdapter multipleSelectAdapter = new MultipleSelectAdapter(this, this.optionList);
                this.rvOption.setAdapter(multipleSelectAdapter);
            }
            linearLayoutManager = new LinearLayoutManager((Context)this);
            linearLayoutManager.setOrientation(RecyclerView.VERTICAL);
            this.rvOption.setLayoutManager((RecyclerView.LayoutManager)linearLayoutManager);
        } else if ((paramBaseBean.getData()).getNextQueVO().getQueType().equals("SELECTD")) {
            this.rvOption.setVisibility(View.VISIBLE);
            this.etBlank.setVisibility(View.GONE);
            if ((paramBaseBean.getData()).getNextQueVO().getExistDesc().booleanValue()) {
                MultipleOptionWitTipAdapter multipleOptionWitTipAdapter = new MultipleOptionWitTipAdapter((Context)this, this.optionList.get(0));
                this.rvOption.setAdapter((RecyclerView.Adapter)multipleOptionWitTipAdapter);
            } else {
                SelectAdapter selectAdapter = new SelectAdapter((Context)this, this.optionList.get(0));
                this.rvOption.setAdapter((RecyclerView.Adapter)selectAdapter);
            }
            linearLayoutManager = new LinearLayoutManager((Context)this) {

                public boolean canScrollHorizontally() {
                    return false;
                }

                public boolean canScrollVertically() {
                    return false;
                }
            };
            linearLayoutManager.setOrientation(RecyclerView.VERTICAL);
            this.rvOption.setLayoutManager((RecyclerView.LayoutManager)linearLayoutManager);
        } else if ((paramBaseBean.getData()).getNextQueVO().getQueType().equals("ANSWER")) {
            this.rvOption.setVisibility(View.GONE);
            this.etBlank.setVisibility(View.VISIBLE);
            this.etBlank.setText((paramBaseBean.getData()).getNextQueVO().getQueResult());
        } else if ((paramBaseBean.getData()).getNextQueVO().getQueType().equals("FILL")) {
            FillInTheBlankDTO fillInTheBlankDTO = null;
            this.fillInTheBlankList = new ArrayList<>();
            if ((paramBaseBean.getData()).getNextQueVO().getQueResult() != null && !"".equals((paramBaseBean.getData()).getNextQueVO().getQueResult())) {
                String[] arrayOfString = (paramBaseBean.getData()).getNextQueVO().getQueResult().split("#@#");
                int i = arrayOfString.length;
                while (b < i) {
                    String str1 = arrayOfString[b];
                    fillInTheBlankDTO = new FillInTheBlankDTO();
                    fillInTheBlankDTO.setBaseId(this.baseId);
                    if ("null".equals(str1)) {
                        fillInTheBlankDTO.setContent("");
                    } else {
                        fillInTheBlankDTO.setContent(str1);
                    }
                    this.fillInTheBlankList.add(fillInTheBlankDTO);
                    b++;
                }
            } else {
                Integer integer1 = (paramBaseBean.getData()).getNextQueVO().getOptionNum();
                this.fillInTheBlankList = new ArrayList<>();
                for (b = 0; b < integer1.intValue(); b++) {
                    FillInTheBlankDTO fillInTheBlankDTO1 = new FillInTheBlankDTO();
                    fillInTheBlankDTO1.setBaseId(this.baseId);
                    this.fillInTheBlankList.add(fillInTheBlankDTO1);
                }
            }
            MultipleFillInTheBlanksListAdapter multipleFillInTheBlanksListAdapter = new MultipleFillInTheBlanksListAdapter(this.fillInTheBlankList);
            this.rvOption.setAdapter((RecyclerView.Adapter)multipleFillInTheBlanksListAdapter);
        }
    }

    private void showQuestionList() {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        View view = LayoutInflater.from(this).inflate(R.layout.dialog_all_question, null);
        ImageView imageView = view.findViewById(R.id.iv_close);
        RecyclerView recyclerView = view.findViewById(R.id.rv_question);
        QuestionAdapter questionAdapter = new QuestionAdapter(this, getAllQueByPaperIdResponseList);
        this.questionAdapter = questionAdapter;
        recyclerView.setAdapter(questionAdapter);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this);
        linearLayoutManager.setOrientation(RecyclerView.VERTICAL);
        recyclerView.setLayoutManager(linearLayoutManager);
        builder.setView(view);
        AlertDialog alertDialog = builder.create();
        alertDialog.show();
        alertDialog.getWindow().setLayout((getResources().getDisplayMetrics()).widthPixels - 100, (getResources().getDisplayMetrics()).heightPixels * 3 / 4);
        imageView.setOnClickListener(v -> alertDialog.dismiss());
        this.questionAdapter.setOnItemClickListener(param1Integer -> {
            jumpQueId = getAllQueByPaperIdResponseList.get(param1Integer).getId();
            savePaperResult(3);
            alertDialog.dismiss();
        });
    }

    private void stopPlayVoice() {
        final OkHttpClient okHttpClient = RetrofitClient.getInstance().getOkHttpClient();
        TreeMap<Object, Object> treeMap = new TreeMap<>();
        treeMap.put("serialNumber", this.serialNumber);
        String str = getSign((TreeMap)treeMap);
        HashMap<Object, Object> hashMap = new HashMap<>();
        hashMap.put("time", Long.valueOf(Long.parseLong(treeMap.get("time").toString())));
        treeMap.remove("time");
        hashMap.put("appkey", this.appKey);
        hashMap.put("language", "zh-CN");
        hashMap.put("sign", str);
        treeMap.put("system", hashMap);
        Gson gson = new Gson();
        RequestBody requestBody = RequestBody.create(this.JSON, gson.toJson(treeMap));
        (new Thread(new Runnable() {
            Request request = new Request.Builder()
                    .url("http://example.com")
                    .post(requestBody)
                    .build();

            public void run() {
                okHttpClient.newCall(request).enqueue(new Callback() {

                    public void onFailure(Call param2Call, IOException param2IOException) {
                        Log.d("MainActivity", "onFailure: " + param2IOException.getMessage());
                    }

                    public void onResponse(Call param2Call, Response param2Response) throws IOException {
                        Log.d("MainActivity", param2Response.protocol() + " " + param2Response.code() + " " + param2Response.message());
                        Headers headers = param2Response.headers();
                        for (byte b = 0; b < headers.size(); b++)
                            Log.d("MainActivity", headers.name(b) + ":" + headers.value(b));
                        Log.d("MainActivity", "onResponse: " + param2Response.body().string());
                    }
                });
            }
        })).start();
    }
}