package com.tjise.asked.adapter;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.graphics.Color;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import androidx.recyclerview.widget.RecyclerView;
import com.tjise.asked.R;
import com.tjise.asked.http.response.QuestionResponse;
import java.util.List;

public class MultipleOptionWitTipAdapter extends RecyclerView.Adapter<MultipleOptionWitTipAdapter.ViewHolder> {
    private static final String TAG = "MultipleOptionWitTipAdapter";

    Context context;

    List<QuestionResponse.NextQueVODTO.OptionListDTO> optionList;

    public MultipleOptionWitTipAdapter(Context paramContext, List<QuestionResponse.NextQueVODTO.OptionListDTO> paramList) {
        this.context = paramContext;
        this.optionList = paramList;
    }

    public int getItemCount() {
        return this.optionList.size();
    }

    public void onBindViewHolder(ViewHolder paramViewHolder, int paramInt) {
        QuestionResponse.NextQueVODTO.OptionListDTO optionListDTO = this.optionList.get(paramInt);
        paramViewHolder.tvOption.setText(optionListDTO.getOptionText());
        if (optionListDTO.getChecked().booleanValue()) {
            paramViewHolder.tvOption.setBackground(this.context.getDrawable(R.drawable.options_checked_radius_border));
            paramViewHolder.tvOption.setTextColor(Color.parseColor("#ffffff"));
            paramViewHolder.ivTip.setImageResource(R.mipmap.icon_tips_checked);
        } else {
            paramViewHolder.tvOption.setBackground(this.context.getDrawable(R.drawable.options_radius_border));
            paramViewHolder.tvOption.setTextColor(Color.parseColor("#333333"));
            paramViewHolder.ivTip.setImageResource(R.mipmap.icon_tips);
        }
        paramViewHolder.tvOption.setOnClickListener(v -> {
            for (int i = 0; i < optionList.size(); i++) {
                if (i == paramInt) {
                    optionList.get(i).setChecked(true);
                } else {
                    optionList.get(i).setChecked(false);
                }
                notifyDataSetChanged();
            }
        });
        paramViewHolder.ivTip.setOnClickListener(v -> {

        });
    }

    public ViewHolder onCreateViewHolder(ViewGroup paramViewGroup, int paramInt) {
        return new ViewHolder(LayoutInflater.from(paramViewGroup.getContext()).inflate(R.layout.adapter_option_with_tip, paramViewGroup, false));
    }

    class ViewHolder extends RecyclerView.ViewHolder {
        ImageView ivTip;
        TextView tvOption;

        public ViewHolder(View param1View) {
            super(param1View);
            this.tvOption = param1View.findViewById(R.id.tv_option);
            this.ivTip = param1View.findViewById(R.id.iv_tip);
        }
    }
}
