package com.tjise.asked.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import androidx.recyclerview.widget.RecyclerView;
import com.google.android.flexbox.FlexboxLayoutManager;
import com.tjise.asked.R;
import com.tjise.asked.http.response.QuestionResponse;
import java.util.List;

public class MultipleSelectAdapter extends RecyclerView.Adapter<MultipleSelectAdapter.ViewHolder> {
    Context context;

    List<List<QuestionResponse.NextQueVODTO.OptionListDTO>> optionListList;

    public MultipleSelectAdapter(Context paramContext, List<List<QuestionResponse.NextQueVODTO.OptionListDTO>> paramList) {
        this.context = paramContext;
        this.optionListList = paramList;
    }

    public int getItemCount() {
        return this.optionListList.size();
    }

    public void onBindViewHolder(ViewHolder paramViewHolder, int paramInt) {
        List<QuestionResponse.NextQueVODTO.OptionListDTO> list = this.optionListList.get(paramInt);
        MultipleOptionAdapter multipleOptionAdapter = new MultipleOptionAdapter(this.context, list);
        RecyclerView recyclerView = paramViewHolder.recyclerView;
        recyclerView.setLayoutManager((RecyclerView.LayoutManager)new FlexboxLayoutManager(this.context) {

            public boolean canScrollHorizontally() {
                return false;
            }

            public boolean canScrollVertically() {
                return false;
            }
        });
        recyclerView.setAdapter(multipleOptionAdapter);
    }

    public ViewHolder onCreateViewHolder(ViewGroup paramViewGroup, int paramInt) {
        return new ViewHolder(LayoutInflater.from(paramViewGroup.getContext()).inflate(R.layout.adapter_multiple_select, paramViewGroup, false));
    }

    class ViewHolder extends RecyclerView.ViewHolder {
        RecyclerView recyclerView;

        public ViewHolder(View param1View) {
            super(param1View);
            this.recyclerView = (RecyclerView)param1View.findViewById(R.id.rv_select);
        }
    }
}
