package com.tjise.asked.adapter;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;
import androidx.recyclerview.widget.RecyclerView;
import com.tjise.asked.R;
import com.tjise.asked.http.response.GetAllQueByPaperIdResponse;
import java.util.List;

public class QuestionAdapter extends RecyclerView.Adapter<QuestionAdapter.ViewHolder> {
    Context context;

    List<GetAllQueByPaperIdResponse> list;

    private OnItemClickListener mOnItemClickListener;

    public QuestionAdapter(Context paramContext, List<GetAllQueByPaperIdResponse> paramList) {
        this.context = paramContext;
        this.list = paramList;
    }

    public int getItemCount() {
        return this.list.size();
    }

    public void onBindViewHolder(ViewHolder paramViewHolder, @SuppressLint("RecyclerView") int paramInt) {
        GetAllQueByPaperIdResponse getAllQueByPaperIdResponse = this.list.get(paramInt);
        paramViewHolder.tvTitle.setText(getAllQueByPaperIdResponse.getId() + " " + getAllQueByPaperIdResponse.getQueTitle());
        paramViewHolder.tvTitle.setTextColor(Color.parseColor("#333333"));
        if (getAllQueByPaperIdResponse.getFinished()) {
            paramViewHolder.tvFinishState.setText("已完成");
            paramViewHolder.tvFinishState.setTextColor(Color.parseColor("#ffffff"));
            paramViewHolder.tvFinishState.setBackgroundColor(Color.parseColor("#0678D9"));
            paramViewHolder.rlBorder.setBackground(this.context.getDrawable(R.drawable.question_checked_radius_border));
            paramViewHolder.tvFinishState.setBackground(this.context.getDrawable(R.drawable.question_checked_radius_border_right));
        } else {
            paramViewHolder.tvFinishState.setText("未完成");
            paramViewHolder.tvFinishState.setTextColor(Color.parseColor("#333333"));
            paramViewHolder.tvFinishState.setBackgroundColor(Color.parseColor("#ffffff"));
            paramViewHolder.rlBorder.setBackground(this.context.getDrawable(R.drawable.question_radius_border));
            paramViewHolder.tvFinishState.setBackground(this.context.getDrawable(R.drawable.question_radius_border_right));
        }
        if (this.mOnItemClickListener != null)
            paramViewHolder.itemView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    mOnItemClickListener.onItemClick(paramInt);
                }
            });
    }

    public ViewHolder onCreateViewHolder(ViewGroup paramViewGroup, int paramInt) {
        return new ViewHolder(LayoutInflater.from(paramViewGroup.getContext()).inflate(R.layout.adapter_question, paramViewGroup, false));
    }

    public void setOnItemClickListener(OnItemClickListener paramOnItemClickListener) {
        this.mOnItemClickListener = paramOnItemClickListener;
    }

    public static interface OnItemClickListener {
        void onItemClick(Integer param1Integer);
    }

    class ViewHolder extends RecyclerView.ViewHolder {
        RelativeLayout rlBorder;

        TextView tvFinishState;

        TextView tvTitle;

        public ViewHolder(View param1View) {
            super(param1View);
            this.tvFinishState = param1View.findViewById(R.id.tv_finish_state);
            this.tvTitle = param1View.findViewById(R.id.tv_title);
            this.rlBorder = param1View.findViewById(R.id.rl_border);
        }
    }
}
