package com.tjise.asked.adapter;

import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
import androidx.recyclerview.widget.RecyclerView;
import com.tjise.asked.R;
import com.tjise.asked.http.response.QuestionResponse;
import java.util.List;

public class SelectAdapter extends RecyclerView.Adapter<SelectAdapter.ViewHolder> {
    private static final String TAG = "SelectAdapter";

    Context context;

    List<QuestionResponse.NextQueVODTO.OptionListDTO> optionList;

    public SelectAdapter(Context paramContext, List<QuestionResponse.NextQueVODTO.OptionListDTO> paramList) {
        this.context = paramContext;
        this.optionList = paramList;
    }

    public int getItemCount() {
        return this.optionList.size();
    }

    public void onBindViewHolder(ViewHolder paramViewHolder, int paramInt) {
        QuestionResponse.NextQueVODTO.OptionListDTO optionListDTO = this.optionList.get(paramInt);
        paramViewHolder.tvOption.setText(optionListDTO.getOptionText());
        if (optionListDTO.getChecked()) {
            paramViewHolder.tvOption.setBackground(context.getDrawable(R.drawable.options_checked_radius_border));
            paramViewHolder.tvOption.setTextColor(Color.parseColor("#ffffff"));
        } else {
            paramViewHolder.tvOption.setBackground(context.getDrawable(R.drawable.options_radius_border));
            paramViewHolder.tvOption.setTextColor(Color.parseColor("#333333"));
        }
        paramViewHolder.tvOption.setOnClickListener(v -> {
            for (int i = 0; i < optionList.size(); i++) {
                if (i == paramInt) {
                    optionList.get(i).setChecked(true);
                } else {
                    optionList.get(i).setChecked(false);
                }
            }
            notifyDataSetChanged();
        });
    }

    public ViewHolder onCreateViewHolder(ViewGroup paramViewGroup, int paramInt) {
        return new ViewHolder(LayoutInflater.from(paramViewGroup.getContext()).inflate(R.layout.adapter_select, paramViewGroup, false));
    }

    class ViewHolder extends RecyclerView.ViewHolder {

        TextView tvOption;

        public ViewHolder(View param1View) {
            super(param1View);
            this.tvOption = (TextView)param1View.findViewById(R.id.tv_option);
        }
    }
}
